LV2: File List

LV2 1.0.13

Data Structures | Typedefs | Functions | Macros
User Interfaces

## Detailed Description

User interfaces of any type for plugins, http://lv2plug.in/ns/extensions/ui for details.

## Data Structures
struct | LV2UI_Descriptor
struct | LV2UI_Resize
struct | LV2UI_Port_Map
struct | LV2UI_Port_Subscribe
struct | LV2UI_Touch
struct | LV2UI_Idle_Interface
struct | LV2UI_Show_Interface
struct | LV2UI_Peak_Data

## Typedefs
typedef void * | LV2UI_Widget
typedef void * | LV2UI_Handle
typedef void * | LV2UI_Controller
typedef void * | LV2UI_Feature_Handle
typedef void(* | LV2UI_Write_Function) (LV2UI_Controller controller, uint32_t port_index, uint32_t buffer_size, uint32_t port_protocol, const void *buffer)
typedef const LV2UI_Descriptor *(* | LV2UI_DescriptorFunction) (uint32_t index)

## Functions
LV2_SYMBOL_EXPORT const LV2UI_Descriptor * | lv2ui_descriptor (uint32_t index)

## Macros
#define | LV2_UI_URI "http://lv2plug.in/ns/extensions/ui"
#define | LV2_UI_PREFIX LV2_UI_URI "#"
#define | LV2_UI__CocoaUI LV2_UI_PREFIX "CocoaUI"
#define | LV2_UI__Gtk3UI LV2_UI_PREFIX "Gtk3UI"
#define | LV2_UI__GtkUI LV2_UI_PREFIX "GtkUI"
#define | LV2_UI__PortNotification LV2_UI_PREFIX "PortNotification"
#define | LV2_UI__PortProtocol LV2_UI_PREFIX "PortProtocol"
#define | LV2_UI__Qt4UI LV2_UI_PREFIX "Qt4UI"
#define | LV2_UI__Qt5UI LV2_UI_PREFIX "Qt5UI"
#define | LV2_UI__UI LV2_UI_PREFIX "UI"
#define | LV2_UI__WindowsUI LV2_UI_PREFIX "WindowsUI"
#define | LV2_UI__X11UI LV2_UI_PREFIX "X11UI"
#define | LV2_UI__binary LV2_UI_PREFIX "binary"
#define | LV2_UI__fixedSize LV2_UI_PREFIX "fixedSize"
#define | LV2_UI__idleInterface LV2_UI_PREFIX "idleInterface"
#define | LV2_UI__noUserResize LV2_UI_PREFIX "noUserResize"
#define | LV2_UI__notifyType LV2_UI_PREFIX "notifyType"
#define | LV2_UI__parent LV2_UI_PREFIX "parent"
#define | LV2_UI__plugin LV2_UI_PREFIX "plugin"
#define | LV2_UI__portIndex LV2_UI_PREFIX "portIndex"
#define | LV2_UI__portMap LV2_UI_PREFIX "portMap"
#define | LV2_UI__portNotification LV2_UI_PREFIX "portNotification"
#define | LV2_UI__portSubscribe LV2_UI_PREFIX "portSubscribe"
#define | LV2_UI__protocol LV2_UI_PREFIX "protocol"
#define | LV2_UI__floatProtocol LV2_UI_PREFIX "floatProtocol"
#define | LV2_UI__peakProtocol LV2_UI_PREFIX "peakProtocol"
#define | LV2_UI__resize LV2_UI_PREFIX "resize"
#define | LV2_UI__showInterface LV2_UI_PREFIX "showInterface"
#define | LV2_UI__touch LV2_UI_PREFIX "touch"
#define | LV2_UI__ui LV2_UI_PREFIX "ui"
#define | LV2_UI__updateRate LV2_UI_PREFIX "updateRate"
#define | LV2_UI__windowTitle LV2_UI_PREFIX "windowTitle"
#define | LV2UI_INVALID_PORT_INDEX ((uint32_t)-1)

## Data Structure Documentation

## ◆ LV2UI_Descriptor

struct LV2UI_Descriptor

A plugin UI.

A pointer to an object of this type is returned by the lv2ui_descriptor() function.

### Data Fields
const char * | URI
LV2UI_Handle(* | instantiate )(const struct _LV2UI_Descriptor *descriptor, const char *plugin_uri, const char *bundle_path, LV2UI_Write_Function write_function, LV2UI_Controller controller, LV2UI_Widget *widget, const LV2_Feature *const *features)
void(* | cleanup )(LV2UI_Handle ui)
void(* | port_event )(LV2UI_Handle ui, uint32_t port_index, uint32_t buffer_size, uint32_t format, const void *buffer)
const void *(* | extension_data )(const char *uri)

#### Field Documentation

## ◆ URI

const char* LV2UI_Descriptor::URI

The URI for this UI (not for the plugin it controls).

## ◆ instantiate

LV2UI_Handle(* LV2UI_Descriptor::instantiate) (const struct _LV2UI_Descriptor *descriptor, const char *plugin_uri, const char *bundle_path, LV2UI_Write_Function write_function, LV2UI_Controller controller, LV2UI_Widget *widget, const LV2_Feature *const *features)

Create a new UI and return a handle to it.

This function works similarly to LV2_Descriptor::instantiate().

Parameters

  descriptor | The descriptor for the UI to instantiate.
  plugin_uri | The URI of the plugin that this UI will control.
  bundle_path | The path to the bundle containing this UI, including the trailing directory separator.
  write_function | A function that the UI can use to send data to the plugin's input ports.
  controller | A handle for the UI instance to be passed as the first parameter of UI methods.
  widget | (output) widget pointer. The UI points this at its main widget, which has the type defined by the UI type in the data file.
  features | An array of LV2_Feature pointers. The host must pass all feature URIs that it and the UI supports and any additional data, as in LV2_Descriptor::instantiate(). Note that UI features and plugin features are not necessarily the same.

## ◆ cleanup

void(* LV2UI_Descriptor::cleanup) (LV2UI_Handle ui)

Destroy the UI.

The host must not try to access the widget after calling this function.

## ◆ port_event

void(* LV2UI_Descriptor::port_event) (LV2UI_Handle ui, uint32_t port_index, uint32_t buffer_size, uint32_t format, const void *buffer)

Tell the UI that something interesting has happened at a plugin port.

What is "interesting" and how it is written to `buffer` is defined by `format`, which has the same meaning as in LV2UI_Write_Function(). Format 0 is a special case for lv2:ControlPort, where this function should be called when the port value changes (but not necessarily for every change), `buffer_size` must be sizeof(float), and `buffer` points to a single IEEE-754 float.

By default, the host should only call this function for lv2:ControlPort inputs. However, the UI can request updates for other ports statically with ui:portNotification or dynamicaly with ui:portSubscribe.

The UI MUST NOT retain any reference to `buffer` after this function returns, it is only valid for the duration of the call.

This member may be NULL if the UI is not interested in any port events.

## ◆ extension_data

const void*(* LV2UI_Descriptor::extension_data) (const char *uri)

Return a data structure associated with an extension URI, typically an interface struct with additional function pointers.

This member may be set to NULL if the UI is not interested in supporting any extensions. This is similar to LV2_Descriptor::extension_data().

## ◆ LV2UI_Resize

struct LV2UI_Resize

Feature/interface for resizable UIs (LV2_UI__resize).

This structure is used in two ways: as a feature passed by the host via LV2UI_Descriptor::instantiate(), or as an interface provided by a UI via LV2UI_Descriptor::extension_data()).

### Data Fields
LV2UI_Feature_Handle | handle
int(* | ui_resize )(LV2UI_Feature_Handle handle, int width, int height)

#### Field Documentation

## ◆ handle

LV2UI_Feature_Handle LV2UI_Resize::handle

Pointer to opaque data which must be passed to ui_resize().

## ◆ ui_resize

int(* LV2UI_Resize::ui_resize) (LV2UI_Feature_Handle handle, int width, int height)

Request/advertise a size change.

When provided by the host, the UI may call this function to inform the host about the size of the UI.

When provided by the UI, the host may call this function to notify the UI that it should change its size accordingly. In this case, the host must pass the LV2UI_Handle to provide access to the UI instance.

Returns
  0 on success.

## ◆ LV2UI_Port_Map

struct LV2UI_Port_Map

Feature to map port symbols to UIs.

This can be used by the UI to get the index for a port with the given symbol. This makes it possible to implement and distribute a UI separately from the plugin (since symbol, unlike index, is a stable port identifier).

### Data Fields
LV2UI_Feature_Handle | handle
uint32_t(* | port_index )(LV2UI_Feature_Handle handle, const char *symbol)

#### Field Documentation

## ◆ handle

LV2UI_Feature_Handle LV2UI_Port_Map::handle

Pointer to opaque data which must be passed to port_index().

## ◆ port_index

uint32_t(* LV2UI_Port_Map::port_index) (LV2UI_Feature_Handle handle, const char *symbol)

Get the index for the port with the given `symbol`.

Returns
  The index of the port, or LV2UI_INVALID_PORT_INDEX if no such port is found.

## ◆ LV2UI_Port_Subscribe

struct LV2UI_Port_Subscribe

Feature to subscribe to port updates (LV2_UI__portSubscribe).

### Data Fields
LV2UI_Feature_Handle | handle
uint32_t(* | subscribe )(LV2UI_Feature_Handle handle, uint32_t port_index, uint32_t port_protocol, const LV2_Feature *const *features)
uint32_t(* | unsubscribe )(LV2UI_Feature_Handle handle, uint32_t port_index, uint32_t port_protocol, const LV2_Feature *const *features)

#### Field Documentation

## ◆ handle

LV2UI_Feature_Handle LV2UI_Port_Subscribe::handle

Pointer to opaque data which must be passed to subscribe() and unsubscribe().

## ◆ subscribe

uint32_t(* LV2UI_Port_Subscribe::subscribe) (LV2UI_Feature_Handle handle, uint32_t port_index, uint32_t port_protocol, const LV2_Feature *const *features)

Subscribe to updates for a port.

This means that the host will call the UI's port_event() function when the port value changes (as defined by protocol).

Calling this function with the same `port_index` and `port_protocol` as an already active subscription has no effect.

Parameters

  handle | The handle field of this struct.
  port_index | The index of the port.
  port_protocol | The URID of the ui:PortProtocol.
  features | Features for this subscription.

Returns
  0 on success.

## ◆ unsubscribe

uint32_t(* LV2UI_Port_Subscribe::unsubscribe) (LV2UI_Feature_Handle handle, uint32_t port_index, uint32_t port_protocol, const LV2_Feature *const *features)

Unsubscribe from updates for a port.

This means that the host will cease calling calling port_event() when the port value changes.

Calling this function with a `port_index` and `port_protocol` that does not refer to an active port subscription has no effect.

Parameters

  handle | The handle field of this struct.
  port_index | The index of the port.
  port_protocol | The URID of the ui:PortProtocol.
  features | Features for this subscription.

Returns
  0 on success.

## ◆ LV2UI_Touch

struct LV2UI_Touch

A feature to notify the host that the user has grabbed a UI control.

### Data Fields
LV2UI_Feature_Handle | handle
void(* | touch )(LV2UI_Feature_Handle handle, uint32_t port_index, bool grabbed)

#### Field Documentation

## ◆ handle

LV2UI_Feature_Handle LV2UI_Touch::handle

Pointer to opaque data which must be passed to ui_resize().

## ◆ touch

void(* LV2UI_Touch::touch) (LV2UI_Feature_Handle handle, uint32_t port_index, bool grabbed)

Notify the host that a control has been grabbed or released.

The host should cease automating the port or otherwise manipulating the port value until the control has been ungrabbed.

Parameters

  handle | The handle field of this struct.
  port_index | The index of the port associated with the control.
  grabbed | If true, the control has been grabbed, otherwise the control has been released.

## ◆ LV2UI_Idle_Interface

struct LV2UI_Idle_Interface

UI Idle Interface (LV2_UI__idleInterface)

UIs can provide this interface to have an idle() callback called by the host rapidly to update the UI.

### Data Fields
int(* | idle )(LV2UI_Handle ui)

#### Field Documentation

## ◆ idle

int(* LV2UI_Idle_Interface::idle) (LV2UI_Handle ui)

Run a single iteration of the UI's idle loop.

This will be called rapidly in the UI thread at a rate appropriate for a toolkit main loop. There are no precise timing guarantees, but the host should attempt to call idle() at a high enough rate for smooth animation, at least 30Hz.

Returns
  non-zero if the UI has been closed, in which case the host should stop calling idle(), and can either completely destroy the UI, or re-show it and resume calling idle().

## ◆ LV2UI_Show_Interface

struct LV2UI_Show_Interface

UI Show Interface (LV2_UI__showInterface)

UIs can provide this interface to show and hide a window, which allows them to function in hosts unable to embed their widget. This allows any UI to provide a fallback for embedding that works in any host.

If used:

- The host MUST use LV2UI_Idle_Interface to drive the UI.
- The UI MUST return non-zero from LV2UI_Idle_Interface::idle() when it has been closed.
- If idle() returns non-zero, the host MUST call hide() and stop calling idle(). It MAY later call show() then resume calling idle().

### Data Fields
int(* | show )(LV2UI_Handle ui)
int(* | hide )(LV2UI_Handle ui)

#### Field Documentation

## ◆ show

int(* LV2UI_Show_Interface::show) (LV2UI_Handle ui)

Show a window for this UI.

The window title MAY have been passed by the host to LV2UI_Descriptor::instantiate() as an LV2_Options_Option with key LV2_UI__windowTitle.

Returns
  0 on success, or anything else to stop being called.

## ◆ hide

int(* LV2UI_Show_Interface::hide) (LV2UI_Handle ui)

Hide the window for this UI.

Returns
  0 on success, or anything else to stop being called.

## ◆ LV2UI_Peak_Data

struct LV2UI_Peak_Data

Peak data for a slice of time, the update format for ui:peakProtocol.

Data Fields
uint32_t | period_start | The start of the measurement period. This is just a running counter that is only meaningful in comparison to previous values and must not be interpreted as an absolute time.
uint32_t | period_size | The size of the measurement period, in the same units as period_start.
float | peak | The peak value for the measurement period. This should be the maximal value for abs(sample) over all the samples in the period.

## Macro Definition Documentation

## ◆ LV2_UI_URI

#define LV2_UI_URI "http://lv2plug.in/ns/extensions/ui"

http://lv2plug.in/ns/extensions/ui

## ◆ LV2_UI_PREFIX

#define LV2_UI_PREFIX LV2_UI_URI "#"

http://lv2plug.in/ns/extensions/ui#

## ◆ LV2_UI__CocoaUI

#define LV2_UI__CocoaUI LV2_UI_PREFIX "CocoaUI"

http://lv2plug.in/ns/extensions/ui#CocoaUI

## ◆ LV2_UI__Gtk3UI

#define LV2_UI__Gtk3UI LV2_UI_PREFIX "Gtk3UI"

http://lv2plug.in/ns/extensions/ui#Gtk3UI

## ◆ LV2_UI__GtkUI

#define LV2_UI__GtkUI LV2_UI_PREFIX "GtkUI"

http://lv2plug.in/ns/extensions/ui#GtkUI

## ◆ LV2_UI__PortNotification

#define LV2_UI__PortNotification LV2_UI_PREFIX "PortNotification"

http://lv2plug.in/ns/extensions/ui#PortNotification

## ◆ LV2_UI__PortProtocol

#define LV2_UI__PortProtocol LV2_UI_PREFIX "PortProtocol"

http://lv2plug.in/ns/extensions/ui#PortProtocol

## ◆ LV2_UI__Qt4UI

#define LV2_UI__Qt4UI LV2_UI_PREFIX "Qt4UI"

http://lv2plug.in/ns/extensions/ui#Qt4UI

## ◆ LV2_UI__Qt5UI

#define LV2_UI__Qt5UI LV2_UI_PREFIX "Qt5UI"

http://lv2plug.in/ns/extensions/ui#Qt5UI

## ◆ LV2_UI__UI

#define LV2_UI__UI LV2_UI_PREFIX "UI"

http://lv2plug.in/ns/extensions/ui#UI

## ◆ LV2_UI__WindowsUI

#define LV2_UI__WindowsUI LV2_UI_PREFIX "WindowsUI"

http://lv2plug.in/ns/extensions/ui#WindowsUI

## ◆ LV2_UI__X11UI

#define LV2_UI__X11UI LV2_UI_PREFIX "X11UI"

http://lv2plug.in/ns/extensions/ui#X11UI

## ◆ LV2_UI__binary

#define LV2_UI__binary LV2_UI_PREFIX "binary"

http://lv2plug.in/ns/extensions/ui#binary

## ◆ LV2_UI__fixedSize

#define LV2_UI__fixedSize LV2_UI_PREFIX "fixedSize"

http://lv2plug.in/ns/extensions/ui#fixedSize

## ◆ LV2_UI__idleInterface

#define LV2_UI__idleInterface LV2_UI_PREFIX "idleInterface"

http://lv2plug.in/ns/extensions/ui#idleInterface

## ◆ LV2_UI__noUserResize

#define LV2_UI__noUserResize LV2_UI_PREFIX "noUserResize"

http://lv2plug.in/ns/extensions/ui#noUserResize

## ◆ LV2_UI__notifyType

#define LV2_UI__notifyType LV2_UI_PREFIX "notifyType"

http://lv2plug.in/ns/extensions/ui#notifyType

## ◆ LV2_UI__parent

#define LV2_UI__parent LV2_UI_PREFIX "parent"

http://lv2plug.in/ns/extensions/ui#parent

## ◆ LV2_UI__plugin

#define LV2_UI__plugin LV2_UI_PREFIX "plugin"

http://lv2plug.in/ns/extensions/ui#plugin

## ◆ LV2_UI__portIndex

#define LV2_UI__portIndex LV2_UI_PREFIX "portIndex"

http://lv2plug.in/ns/extensions/ui#portIndex

## ◆ LV2_UI__portMap

#define LV2_UI__portMap LV2_UI_PREFIX "portMap"

http://lv2plug.in/ns/extensions/ui#portMap

## ◆ LV2_UI__portNotification

#define LV2_UI__portNotification LV2_UI_PREFIX "portNotification"

http://lv2plug.in/ns/extensions/ui#portNotification

## ◆ LV2_UI__portSubscribe

#define LV2_UI__portSubscribe LV2_UI_PREFIX "portSubscribe"

http://lv2plug.in/ns/extensions/ui#portSubscribe

## ◆ LV2_UI__protocol

#define LV2_UI__protocol LV2_UI_PREFIX "protocol"

http://lv2plug.in/ns/extensions/ui#protocol

## ◆ LV2_UI__floatProtocol

#define LV2_UI__floatProtocol LV2_UI_PREFIX "floatProtocol"

http://lv2plug.in/ns/extensions/ui#floatProtocol

## ◆ LV2_UI__peakProtocol

#define LV2_UI__peakProtocol LV2_UI_PREFIX "peakProtocol"

http://lv2plug.in/ns/extensions/ui#peakProtocol

## ◆ LV2_UI__resize

#define LV2_UI__resize LV2_UI_PREFIX "resize"

http://lv2plug.in/ns/extensions/ui#resize

## ◆ LV2_UI__showInterface

#define LV2_UI__showInterface LV2_UI_PREFIX "showInterface"

http://lv2plug.in/ns/extensions/ui#showInterface

## ◆ LV2_UI__touch

#define LV2_UI__touch LV2_UI_PREFIX "touch"

http://lv2plug.in/ns/extensions/ui#touch

## ◆ LV2_UI__ui

#define LV2_UI__ui LV2_UI_PREFIX "ui"

http://lv2plug.in/ns/extensions/ui#ui

## ◆ LV2_UI__updateRate

#define LV2_UI__updateRate LV2_UI_PREFIX "updateRate"

http://lv2plug.in/ns/extensions/ui#updateRate

## ◆ LV2_UI__windowTitle

#define LV2_UI__windowTitle LV2_UI_PREFIX "windowTitle"

http://lv2plug.in/ns/extensions/ui#windowTitle

## ◆ LV2UI_INVALID_PORT_INDEX

#define LV2UI_INVALID_PORT_INDEX ((uint32_t)-1)

The index returned by LV2UI_Port_Map::port_index() for unknown ports.

## Typedef Documentation

## ◆ LV2UI_Widget

typedef void* LV2UI_Widget

A pointer to some widget or other type of UI handle.

The actual type is defined by the type of the UI.

## ◆ LV2UI_Handle

typedef void* LV2UI_Handle

A pointer to UI instance internals.

The host may compare this to NULL, but otherwise MUST NOT interpret it.

## ◆ LV2UI_Controller

typedef void* LV2UI_Controller

A pointer to a controller provided by the host.

The UI may compare this to NULL, but otherwise MUST NOT interpret it.

## ◆ LV2UI_Feature_Handle

typedef void* LV2UI_Feature_Handle

A pointer to opaque data for a feature.

## ◆ LV2UI_Write_Function

typedef void(* LV2UI_Write_Function) (LV2UI_Controller controller, uint32_t port_index, uint32_t buffer_size, uint32_t port_protocol, const void *buffer)

A host-provided function that sends data to a plugin's input ports.

Parameters

  controller | The opaque controller pointer passed to LV2UI_Descriptor::instantiate().
  port_index | Index of the port to update.
  buffer | Buffer containing `buffer_size` bytes of data.
  buffer_size | Size of `buffer` in bytes.
  port_protocol | Either 0 or the URID for a ui:PortProtocol. If 0, the protocol is implicitly ui:floatProtocol, the port MUST be an lv2:ControlPort input, `buffer` MUST point to a single float value, and `buffer_size` MUST be sizeof(float). The UI SHOULD NOT use a protocol not supported by the host, but the host MUST gracefully ignore any protocol it does not understand.

## ◆ LV2UI_DescriptorFunction

typedef const LV2UI_Descriptor*(* LV2UI_DescriptorFunction) (uint32_t index)

The type of the lv2ui_descriptor() function.

## Function Documentation

## ◆ lv2ui_descriptor()

LV2_SYMBOL_EXPORT const LV2UI_Descriptor* lv2ui_descriptor | ( | uint32_t | index | ) |

Prototype for UI accessor function.

This is the entry point to a UI library, which works in the same way as lv2_descriptor() but for UIs rather than plugins.